



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用python制作ArcGIS插件（3）ArcPy的使用说明</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用python制作ArcGIS插件（3）ArcPy的使用说明</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 07:18:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>使用python制作ArcGIS插件（3）ArcPy的使用说明</p>
<p>by 李远祥</p>
<p>ArcPy 是一个以成功的 arcgisscripting 模块为基础并继承了 arcgisscripting 功能进而构建而成的站点包。目的是为以实用高效的方式通过 Python 执行地理数据分析、数据转换、数据管理和地图自动化创建基础。</p>
<p>该包提供了丰富纯正的 Python 体验，具有代码自动完成功能（输入关键字和点即可获得该关键字所支持的属性和方法的弹出列表；从中选择一个属性或方法即可将其插入），并针对每个函数、模块和类提供了参考文档。</p>
<p>在 Python 中使用 ArcPy 的另一个主要原因是，Python 是一种通用的编程语言。Python 是一种支持动态输入的解释型语言，适用于交互式操作以及为称为脚本的一次性程序快速制作原型，同时其具有编写大型应用程序的强大功能。用 ArcPy 编写的 ArcGIS 应用程序的优势在于，可以使用由来自多个不同领域的 GIS 专业人员和程序员组成的众多 Python 小群体开发的附加模块。</p>
<p>上述灰色字体介绍部分来自ArcGIS的官方帮助说明，可以帮助大家了解ArcPy的来龙去脉。从帮助上看出，Arcpy可以做的几项重要的工作，地理数据分析、数据转换、数据管理和地图自动化创建。其中，地理数据分析、数据转换、数据管理都是toolbox的工具都可以实现，地图自动化创建则是需要工具以外的东西，则需要开放更多的接口进行地图的交互。</p>
<p>接下来可以看看ArcPy到底提供了哪些操作的接口。学习ArcPy最重要的还是使用Desktop的帮助，这个帮助基本上就是一个cookbook，所需要的都可以在帮助里面找到，可以根据帮助看看那些操作能用，哪些不能用。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/820302/201610/820302-20161009143444456-401990681.png"></p>
<p>从帮助里面可以看到ArcPy里面设计到的功能部分，涉及到常规操作的一些函数、类、数据接入、制图等，还有提供一些非工具调用的扩展模块的特殊接口，这些接口都是交互性的接口。如果希望能够完全使用python进行插件开发，那必须掌握工具的调用（也就是说知道哪些工具能实现什么什么功能），以及ArcPy的函数和类，与地图交互部分，必须掌握Mapping模块，因为该模块涉及到地图的交互操作。</p>
<p>ArcPy函数部分，基本上将AO常用的操作部分进行了封装，而且调用相当简介。可以看到游标、字段、地理数据库管理等的接口。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/820302/201610/820302-20161009143445503-1798527841.png"></p>
<p>例如看搜索游标的调用实例，相对与AO来说，简直就是简单到极致，完全符合常规的思维模式。指定数据源，查找字段等就能查出结果。</p>
<div>
<pre class="prettyprint linenums">import arcpy

fc = "c:/data/base.gdb/roads"
field = "StreetName"
cursor = arcpy.SearchCursor(fc)
for row in cursor:
    print(row.getValue(field))</pre>
</div>
<p>例如列出数据，非常简介的调用，遍历出各种数据的列表</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/820302/201610/820302-20161009143446987-1397330686.png"></p>
<p>调用也是非常简单</p>
<div>
<pre class="prettyprint linenums">import arcpy

# For each field in the Hospitals feature class, print
#  the field name, type, and length.
fields = arcpy.ListFields("c:/data/municipal.gdb/hospitals")

for field in fields:
    print("{0} is a type of {1} with a length of {2}"
          .format(field.name, field.type, field.length))</pre>
</div>
<p>从这两个例子可以看出，ArcPy的设计都是以极简思维去设计接口和函数的，尽可能符合人类思维模式，避免了像其他高级语言那样严格的通过定义变量、变量类型等严格的操作。</p>
<p>再看涉及到的类型，一些常规的细粒度控制也做得相当不错。哪怕是图形的控制，都可以通过ArcPy来控制。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/820302/201610/820302-20161009143447847-1620754874.png"></p>
<p>例如创建一个面，通过ArcPy只需要几行简单的代码，完成面要素创建并加入到已有的面图层中</p>
<div>
<pre class="prettyprint linenums">import arcpy

# A list of features and coordinate pairs
feature_info = [[[1, 2], [2, 4], [3, 7]],
                [[6, 8], [5, 7], [7, 2], [9, 5]]]

# A list that will hold each of the Polygon objects
features = []

for feature in feature_info:
    # Create a Polygon object based on the array of points
    # Append to the list of Polygon objects
    features.append(
        arcpy.Polygon(
            arcpy.Array([arcpy.Point(*coords) for coords in feature])))

# Persist a copy of the Polyline objects using CopyFeatures
arcpy.CopyFeatures_management(features, "c:/geometry/polygons.shp")</pre>
</div>
<p>在制图方面，同样可以看到一些细粒度的控制，如涉及到地图文档控制、符号控制等</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/820302/201610/820302-20161009143448628-581179859.png"></p>
<p>可以说，这些都是可以从各个细节地方去控制地图，并做出一些交互操作。掌握了这些基本的函数和类，对于基本一定GIS基础的开发人员来说，基本上可以制作出各种的插件了，避免使用AO去做长周期的开发。</p>
<p>个人认为，如果将ArcGIS插件式开发定义为使用ArcPy去开发的话，那就太局限了。因为python是一个优秀的语言，有着活跃的开发社区，有非常多的优秀算法和优秀的资源，可以通过python的模式而不是仅仅限于ArcPy去开发插件，这才能做出更加优秀的功能。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kp1739.html">Maven的Missing artifact问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eov0mq.html">场景5 Performance Management</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gld1q.html">c&num;小小总结（设计模式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96zrkvq.html">Code First ：使用Entity&period; Framework编程&lpar;1&rpar;  ----转发 收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rw437q.html">YARN中自己总结的几个关键点</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q264jo9.html">mongodb分布式查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nvooq.html">修改vb程序图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yzdonq.html">EnterpriseLibrary4 自己封装程序集实现log打印</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v4w69.html">lintcode &colon;最长上升连续子序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05zn4q.html">&lpar;转&rpar;iOS7界面设计规范&lpar;2&rpar; - UI基础 - iOS应用解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1znwk9.html">观察者模式与Boost&period;Signals</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k50l59.html">从零深入 tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/90me0448.html">python大小写转换函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jlpzq.html">【转载】关于api-ms-win-crt-runtimel1-1-0&period;dll缺失的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdprk7xq.html">spring boot 自己输出json数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k10z29.html">用for&semi; while&period;&period;&period;do&semi; do&period;&period;&period;while&semi; 写出九九乘法表</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k0g569.html">Topshelf：一款非常好用的 Windows 服务开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyzy0q.html">2Sum问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2kyoe8.html">java把指定文字输出为图片流，支持文字换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlwgdy9.html">剑指offer二十九之最小的K个数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zmpl59.html">NOIP2016DAY1题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zdpoq.html">Linux包管理工具分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zmml59.html">Tomcat热部署：Maven项目一键部署到Tomcat服务器 - 支持多环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melwl0q.html">iOS开发&mdash;&mdash;判断是否第一次启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zor6yvq.html">JQuery的 jQuery&period;fn&period;extend&lpar;&rpar; 和jQuery&period;extend&lpar;&rpar;&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd33g8.html">&lbrack;osg&rsqb;osg显示中文信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melxy0q.html">Python 一些常用模块的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zl3ex9.html">angularjs---服务&lpar;service &sol; factory &sol; provider&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p7gej8.html">Mac 安装Eclipse</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey565m9.html">bmp图片显示</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
